# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['caspar_church']

package_data = \
{'': ['*']}

install_requires = \
['amcp-pylib>=0.2.2,<0.3.0',
 'bible3>=1.0.0,<2.0.0',
 'python-scriptures>=3.0.0,<4.0.0',
 'striprtf>=0.0.21,<0.0.22']

setup_kwargs = {
    'name': 'caspar-church',
    'version': '0.0.1',
    'description': 'A CasparCG client designed for displaying lyrics, bible verses and video on multiple outputs.',
    'long_description': '=======================================\nRelease notes for CasparCG Church 1.2.1\n=======================================\n\nNow Tested with CasparCG v2.3 on Windows\n========================================\n\nFeatures still under development:\n---------------------------------\n  * In the amcp_pylib Package An ADD STREAM command does not work(This is for streaming a channel to VLC for Preview .Etc).\n  * Intigrating asyncio comand loops.\n\nKnown issues:\n-------------\n  * although theoretically multiple copy\'s of CasparCG church can be run on different machines on the LAN, each managing different aspects of the service. Currently CasparCG church(Client) can only connect to a CasparCG(server) on the same machine. However if you want a second client managing motion graphics it can be done using the official CasparCG client.\n  * Note: When searching for a bible passage some 3 character bible abbreviations will not work at the moment. for instance "exo 20:1" instead use 4 character abbreviations, "exod 20:1"\n\n\nOperational overview:\n---------------------\n CasparCG Church is a client for CasparCG.\n when you run CasparCG Church the following wil occur.\n The BibleXML will be loaded. (This is specified in the installation instructions The BibleXML needs to be stored in the same Folder as Caspar_Church.py)\n (Note: the .ftd files listed in this document are "stored data" files on the Caspar server)\n Server_settings.ftd is retreved from the CasparCG server, this xml contains presets specific to this server.(this file is generated if none exists.)\n Rundown.ftd is loaded from the server, this xml contains the data needed to RE-generate the rundown if a rundown has been saved.\n Thumbnails are loaded from the server and stored locally in Thumbnail.xml(This to decrees loading time on future startups.)\n The "Master media List" is loaded, the main reason for making this was to debug thumbnails, however it is also useful for testing video and still images. video/stills will be played on channel 1, layer 10, not looping.\n \n After loading a song, when you click a slide. all the details of the current slide are saved as current_data.ftd. Then for each channel a CG_ADD command is issued to apply the template.\n if the next slide played uses the same template as the previous template. a CG_UPDATE command is issued instead, this is to increase responsiveness\n\n if the slide you clicked has media attached that media will be played on the appropriate channel or channels on the specified layer(Note: to play media on multiple channels at once enter the channels in CSV format I.E. 1,2 2,3 1,2,3 .etc).\n\n if the slide clicked has a timer attached. the next slide will play after the specified seconds.\n\n The slide text will be sent as f0 through whatever is specified in "Bible, max lines per slide" under settings.\n\n The next slide will be sent as b0 through "Bible, max lines per slide".\n\n if the slide contains header information, that is sent as h0 to infinity.\n\n if the slide contains a reference, that will be sent as ref.\n\n      Note: all the aforementioned data is stored automatically as current_data.\n\n If a video is played, the time the video should finish is stored as the variable "Video_Seconds". when f7 is pressed a countdown timer will be displayed showing the remaining time, on the stage display channel.\n\n You can click and drag the items in the rundown to change their agangement. This also works in the song arangement.\n\nHotkeys:\n========\n  * **General:**\n  \n    * **F1:** Clears all channels\n    * **f2:** Clear all templates on layer 20\n    * **f3:** Clear all Media on layer 10(video default)\n    * **f6:** Fade to black all channels,(layer 10 only) useful when using a trimmed media file.\\\n    * **f7:** Displays the video countdown on the stage display channel (The last channel, if 3 channels are configured stage display is channel 3) on layer 21.\n    * **f8:** Pause and resume any movie played on layer 5of any channel( NOTE: the PAUSE command is Broken in amcp_pylib.Basic module; it actually sends a **PLAY** command, 5 second fix in line 40 of basic.py).\n    * **f9:** streaming test code(not functional) also test code for playing a webcam.\n    * **f11:** Caspar info test code(not functional, experiment to query what is playing)\n    * **f12:** additional test code depreciated, extra\n    * **Up:** Play Previous rundown item\n    * **Down:** Play next Rundown item\n    * **Left:** Play previous slide\n    * **Right:** Play next slide\n\n  * **While in the verse editor:**\n    * **Ctrl+r** Split the current slide into multiple slides, A blank line is used for splitting.\n\n      example:\n\n      line1\n\n      line2\n\n      line3\n\n      line4\n\n    * **Ctrl+d** Condense the text of all the slides of the current verse into one slide(note this is for the slide text only Reference, Header, media .Etc is all lost when verse is saved).\n\n  * **While in chose media:**\n    After selecting the desired media file hit enter to display the thumbnail(if the media file is a MOVIE The trim media bar will be displayed).\n\n    **Trim media hotkeys**: (Note: preview is only available at this time via a stream consumer on the server and not in the client itself)\n    * **Note**: on CasparCG server version 2.1 NOT 2.1 Beta2, trimming a movie will only be accurate to within a few seconds not to the exact frame. on a short clip (under 20 minutes) trim points are accurate to within one second. on a longer clip(50 minutes or longer) the accuracy is within 5 seconds. I recommend using **f6** to end a clip early if this is a issue .\n    * **q** and **e** adjusts the start frame\n    * **w** plays the first 30 frames after the start frame, The first frame played is where the video will start.\n    * **a** and **d** adjusts the length\n    * **s** plays the last 30 frames, The final frame played is where the video will end.\n\nInstallation instructions for CasparCG church.\n==============================================\n\n Note: these instructions assume you are already familiar with CasparCG and already have CasparCG installed.\n\n From your Python Console:\n\n **pip install Carpar_chruch**\n\n **click the settings button on the main form.**\n\n You will need to enter the biblename (optional), server ip and server port.\n\n enter the number of channels on your caspar server (this is crucial for working with multiple channels).\n\n if you use the bible template I have provided set **"Bible, max line legnth"** to **45** and **"Bible, max lines per slide"** to **4.**\n\n you will notice there is a template profile named "bible". This is the profile used on bible verses, you will need to select your desired templates before sending bible verses.\n\n you will notice a button named add verse profiles here you can save button colors and versenames presets. (accessible from the edit verse form simply click a **verse name** and hit **enter**).\n\n you are now ready to create a song or do whatever your worship leader insists. :D\n ',
    'author': 'Jeffrey Rydell',
    'author_email': 'None',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'None',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.8,<4.0',
}


setup(**setup_kwargs)
